qq_33164870
qq_33164870
采纳率0%
2018-12-28 11:31

有关兼容7.0安装eclipse和Android studio问题

eclipse中下载后安装没有兼容7.0版本及以上,下载完apk后能成功进行安装,但是在Android Studio中没有进行7.0以上安装兼容就无法进行安装,会报错怎么回事eclipse中安装代码Android studio中安装代码

  • 点赞
  • 写回答
  • 关注问题
  • 收藏
  • 复制链接分享
  • 邀请回答

1条回答

  • sxt_zls Go’ball 3年前

    这是因为Android7.0开始 , 系统加了限制, 私有文件不能随意访问
    图片说明

    所以解决方案就是

    public void installApk() {
    if (apkFile != null && apkFile.exists()) {
    Intent installApkIntent = new Intent();
    installApkIntent.addCategory(Intent.CATEGORY_DEFAULT);
    installApkIntent.setAction(Intent.ACTION_VIEW);
    installApkIntent.setFlags(Intent.FLAG_ACTIVITY_NEW_TASK);

            if (Build.VERSION.SDK_INT > Build.VERSION_CODES.M) {
                installApkIntent.addFlags(Intent.FLAG_GRANT_READ_URI_PERMISSION | Intent.FLAG_GRANT_WRITE_URI_PERMISSION);
                installApkIntent.setDataAndType(FileProvider.getUriForFile(activity.getApplicationContext(), activity.getPackageName() + ".fileprovider", apkFile), "application/vnd.android.package-archive");
            } else {
                installApkIntent.setDataAndType(Uri.fromFile(apkFile), "application/vnd.android.package-archive");
            }
            if (activity.getPackageManager().queryIntentActivities(installApkIntent, 0).size() > 0) {
                activity.getApplicationContext().startActivity(installApkIntent);
            }
        } else {
            ToastUtil.showToast(activity, "下载文件失败,请重新登录进行升级");
        }
    }
    

    在7.0及以下 , 这种方式完全OK ; 但是8.0及以上 , Anroid系统出于安全考虑 , 进一步限制了未知来源apk的安装 ; 需要进行用户授权 , 允许安装未知来源的应用 , 才能正常安装我们自己下载的apk文件

    图片说明

    图片说明

    具体实现可以参考我的博客

    点赞 评论 复制链接分享